#!/usr/bin/env python

import logging
from socketserver import TCPServer
from collections import defaultdict

from umodbus import conf
from umodbus.server.tcp import RequestHandler, get_server
from umodbus.utils import log_to_stream

# Add stream handler to logger 'uModbus'.
#log_to_stream(level=logging.DEBUG)

# A very simple data store which maps addresss against their values.
#data_store = defaultdict(int)
holding_regs = {0:1,1:2}
input_regs = {0:3,1:4}
# Enable values to be signed (default is False).
#conf.SIGNED_VALUES = True

TCPServer.allow_reuse_address = True
app = get_server(TCPServer, ('localhost', 502), RequestHandler)

@app.route(slave_ids=[0], function_codes=[4], addresses=list(range(0, 10)))
def read_data_store(slave_id, function_code, address):
    """" Return value of address. """    
    return input_regs[address]

@app.route(slave_ids=[0], function_codes=[3], addresses=list(range(0, 10)))
def read_data_store(slave_id, function_code, address):
    """" Return value of address. """
    return holding_regs[address]


@app.route(slave_ids=[0], function_codes=[6, 16], addresses=list(range(0, 10)))
def write_data_store(slave_id, function_code, address, value):
    """" Set value for address. """
    holding_regs[address] = value

if __name__ == '__main__':
    try:
        app.serve_forever()
    finally:
        app.shutdown()
        app.server_close()